;   LC-    
;  ATtiny2313.    Fo=10'000'000 .
;
;        
; Cx=COEFF_C*[nx*No/no*Nx-1], 
; Ro-    ,    
; Co-    ,    
; nx-   Fo,      Nx   ,
;  (Cx+Co)*Ro
; no-   Fo,      Nx   ,
;  Ro*Co  

;   L     
; Lx=COEFF_L*[(nx*No/no*Nx)^2-1]
;  nx-      (Fo)    Nx
; no-   Fo    No
; Nx-            
; No-            

; 

;   "0".      no, No   
;   "0.00",  "0" .
;       "x"    .
;       "Lx"  .

;   RAM
; $68-    100
; $69-     10
; $6A-      1
; $6B-      

; $6C-    
; $6E- KEY
; $6F-      

; $76...$79  nx
; $86...$89  Nx
;***************************************************************************
;PB0- A
;PB1- B
;PB2- C
;PB3- D
;PB4- E
;PB5- F
;PB6- G
;PB7- H

;PD2- 
;PD3- 1
;PD4- 10
;PD5- 100

;PD0- ">0<"
;PD1- "C/L"

;PD6- ICP

;***************************************************************************


	.INCLUDE "2313def.inc"

	.def	A	=r16
	.def	B	=r17
	.def	H	=r18
	.def	L	=r19
	.def	D	=r20
	.def	E	=r21
	.def	F	=r22
	.def	G	=r23
	.def	J	=r24
	.def	K	=r25

	.equ	DCLK	=0
	.equ	DOUT	=1
	
	.equ	DIAPAZON=$7F
	.equ	RAM_PEREGRUZKA=$7E

	.equ	ANODE	=$6F
	.equ	KEY	=$6E
	.equ	MINUS	=$6C
	
	.equ	INDR	=$6B
	.equ	IND1	=$6A
	.equ	IND10	=$69
	.equ	IND100	=$68
;************************************************
	.equ	RAM_COEFF_C	=$90
	.equ	RAM_CONST_C	=$94
	.equ	RAM_CONST_Lo	=$98
	.equ	RAM_CONST_L	=$9C

	.ESEG
	.ORG	$50
;***************************************************************************
; ,     Co=6080 pF
;***************************************************************************
COEFF_C:
	.DB	$00,$9A,$44,$09		; Co*1000*K
E_CONST_C:
	.DB	$01,$5A,$39,$2E		;    EEPROM
					;
;***************************************************************************
; ,     Lo=502 mkH Co=6080 pF
;***************************************************************************
COEFF_L:
	.DB	$00,$07,$5D,$44		; Lo*1000*K
E_CONST_L:
	.DB	$02,$99,$70,$26		;    EEPROM
E_END:
;************************************************
	.CSEG

	.ORG	$00
RESET:
	RJMP	START		; On Reset
	SET			; On Interrupt 0
	RETI			; On Interrupt 1

	RJMP	CAPT		; Timer 1 capture
	RJMP	TIMER_COMP1	; Timer 1A compare
;***************************************************************************
;24.05.2010
	ADIW	XL,1
	CPI	XH,10		;   ~16.8 
	BRCS	IZM

	SET
IZM:
	RETI
;***************************************************************************
DC_ANODE:
	.DB	$63,$53,$4B,$47
TTB_IND:
	.DB	$C0,$F9	; 0,1
	.DB	$A4,$B0	; 2,3
	.DB	$99,$92	; 4,5
	.DB	$82,$F8	; 6,7
	.DB	$80,$90	; 8,9
;	.DB	$8C,$DC	; p,n
;	.DB	$8D,$FF	; u,
;***************************************************************************
START:
	LDI	R16,LOW(RAMEND)
	OUT	SPL,R16

	LDI	R20,0b11111111
	OUT	DDRB,R20	;
	OUT	PORTB,R20
	
	OUT	DDRD,R20	;
	LDI	R20,0b01000011
	OUT	PORTD,R20
	
	LDI	R20,0b00111100
	OUT	DDRD,R20	;

	CLR	ZH	
	LDI	ZL,$60
	RCALL	CLEAR_R64
	
	SER	R20
	STS	IND100,R20
	STS	IND10,R20
	STS	IND1,R20
	STS	INDR,R20	; 
;***************************************************************************
	LDI	ZL,LOW(COEFF_C)
	LDI	YL,LOW(COEFF_C+$40)
RAM_E:
	RCALL	EEREAD
	ST	Y,R0
	INC	YL
	INC	ZL
	CPI	ZL,LOW(E_END)
	BRNE	RAM_E
;***************************************************************************
SCHIT:
	CLI
	CLR	ZH

	LDI	A,$80
	OUT	ACSR,A		; OFF ANALOG COMP
	
	STS	MINUS,ZH
	STS	RAM_PEREGRUZKA,ZH
	STS	ANODE,ZH

	LDI	R16,$23		;   INT0,   
	OUT	MCUCR,R16	;  

	OUT	TCCR1B,ZH
	OUT	TCNT1H,ZH
	OUT	TCNT1L,ZH

	LDI	R18,HIGH(16433)
	OUT	OCR1AH,R18

	LDI	R19,LOW(16433)
	OUT	OCR1AL,R19

	LDI	R20,$40
	OUT	TIMSK,R20	;  OCR1A
	OUT	GIMSK,R20	;  INT0

	SER	R20		
	OUT	TIFR,R20	;  FLAG
	OUT	GIFR,R20

	LDI	R20,$01		;   1
	OUT	TCCR1B,R20

	CLT
	SEI
WAIT_BEGIN_IND:
;	SLEEP
	BRTC	WAIT_BEGIN_IND
;***************************************************************************
;        
;***************************************************************************
	CLI
	CLT
	SBIS	PIND,0
	RJMP	CALIBROVKA
	SBIS	PIND,1
	RCALL	RESULT_Lx
	SBIC	PIND,1
	RCALL	RESULT_Cx
RES_GO:
;***************************************************************************
	LDS	R20,RAM_PEREGRUZKA
	TST	R20
	BRNE	PEREGRUZKA
;***************************************************************************
	RCALL	BAND
	LDS	R20,DIAPAZON
	CPI	R20,11
	BRCS	RES_G01
PEREGRUZKA:	
	LDI	R16,$FE		; ,   A   
	MOV	R17,R16
	MOV	R18,R16
	MOV	R19,R16
	RJMP	RES_GO3		;    
RES_G01:
	RCALL	BIN_BCD
	RCALL	CODIR
	RCALL	INDEX_DEC_POINT
RES_GO3:
	LDS	R20,MINUS
	TST	R20
	BRPL	PLUS
	CBR	R19,$80
PLUS:
	STS	IND100,R16
	STS	IND10,R17
	STS	IND1,R18
	STS	INDR,R19

	RJMP	SCHIT
;***************************************************************************
;***************************************************************************
;***************************************************************************
;***************************************************************************
;***************************************************************************
;***************************************************************************
;***************************************************************************
RESULT_Lx:
	RCALL	RABOTA
RESULT_Lx_CAL:
	LDI	ZL,$0A
	RCALL	CLEAR_R10	;   R10...R19
	
	LDI	ZL,LOW(RAM_CONST_L)

	LD	R16,Z+
	LD	R17,Z+
	LD	R18,Z+
	LD	R19,Z	;  65536*65536*No/no  RAM
	
	RCALL	RES_nox		;  nx
	
	RCALL 	MULT	;  (65536*65536*No/no)*nx

	RCALL	RES_Nx		;  Nx

	RCALL	DIV	;  [(65536*65536*No/no)*nx]/Nx

	MOV	R10,R0
	MOV	R11,R1
	MOV	R12,R2
	MOV	R13,R3
	MOV	R14,R4
	MOV	R15,R5
	MOV	R16,R6
	MOV	R17,R7
	MOV	R18,R8
	MOV	R19,R9	;        nx*No*65536/no*Nx

	RCALL 	MULT	;  {[(65536*65536*No/no)*nx]/Nx}^2
;***************************************************************************
	LDI	R20,1
	
	SUB	R1,R20
	SBC	R0,ZH	;  {[(No/no)*(nx/Nx)]^2-1}*65536^4

	TST	R0
	BRPL	RES_Lx01
	
	LDI	R20,$80
	STS	MINUS,R20
	
	RCALL	CONV
	
RES_Lx01:
	MOV	R9,R5
	MOV	R8,R4
	MOV	R7,R3
	MOV	R6,R2
	MOV	R5,R1
	MOV	R4,R0
	CLR	R3
	CLR	R2
	CLR	R1
	CLR	R0

	LDI	ZL,$0A
	RCALL	CLEAR_R10	;   R10...R19
	
	LDI	ZL,LOW(RAM_CONST_Lo)
;Q:
	LD	R16,Z+
	LD	R17,Z+
	LD	R18,Z+
	LD	R19,Z

	RCALL 	MULT	;  Lo*1'000*{[(No/no)*(nx/Nx)]^2-1}

	MOV	R9,R5
	MOV	R8,R4
	MOV	R7,R3
	MOV	R6,R2
	MOV	R5,R1
	MOV	R4,R0
	CLR	R3
	CLR	R2
	CLR	R1
	CLR	R0
		;      
	RET
;************************************************
RESULT_Cx:
	RCALL	RABOTA
RESULT_Cx_CAL:
	LDI	ZL,$0A
	RCALL	CLEAR_R10	;   R10...R19
	
	LDI	ZL,LOW(RAM_CONST_C)
	LD	R16,Z+
	LD	R17,Z+
	LD	R18,Z+
	LD	R19,Z
	
	RCALL	RES_nox		;  nx
	
	RCALL	MULT		; (65536*65536*No/no)*nx
	
	RCALL	RES_Nx		;  Nx

	RCALL	DIV		; [(65536*65536*No/no)*nx]/Nx
;***************************************************************************
	LDI	R20,1

	SUB	R5,R20
	SBC	R4,ZH
	SBC	R3,ZH
	SBC	R2,ZH
	SBC	R1,ZH
	SBC	R0,ZH		; [(65536*65536*No/no)*(nx/Nx)]-1 0000 0000
	
	TST	R0
	BRPL	RES_Cx01
	
	LDI	R20,$80
	STS	MINUS,R20

	RCALL	CONV	
RES_Cx01:
;***************************************************************************
	LDI	ZL,$0A
	RCALL	CLEAR_R10	;     

	LDI	ZL,LOW(RAM_COEFF_C)
;	RJMP	Q
	
	LD	R16,Z+
	LD	R17,Z+
	LD	R18,Z+
	LD	R19,Z

	RCALL	MULT	

	MOV	R9,R5
	MOV	R8,R4
	MOV	R7,R3
	MOV	R6,R2
	MOV	R5,R1
	MOV	R4,R0
	CLR	R3
	CLR	R2
	CLR	R1
	CLR	R0
		;      
	RET
;***************************************************************************
CALIBROVKA:
	SBIC	PIND,1
	RJMP	CALIBROVKA_C
CALIBROVKA_L:
;***************************************************************************
;   N  n   No  no
;65536*65536*No/no
;***************************************************************************
	RCALL	RABOTA
	
	LDI	R21,20
	LDI	ZL,$00
	RCALL	CLEAR0		;   R0...R19
	
	LDS	R2,$86
	LDS	R3,$87
	LDS	R4,$88
	LDS	R5,$89		;  N*65536^2
	
	LDS	R16,$76
	LDS	R17,$77
	LDS	R18,$78
	LDS	R19,$79		;  n
	
	RCALL	DIV

	STS	RAM_CONST_L+0,R6
	STS	RAM_CONST_L+1,R7
	STS	RAM_CONST_L+2,R8
	STS	RAM_CONST_L+3,R9

	RCALL	RESULT_Lx_CAL
;***************************************************************************
;      EEPROM	
	RCALL	SAVE
	RJMP	RES_GO
;***************************************************************************
CALIBROVKA_C:
;65536*65536*No/no
	RCALL	RABOTA

	LDI	R21,20
	LDI	ZL,$00
	RCALL	CLEAR0		;   R0...R19

	LDS	R2,$86
	LDS	R3,$87
	LDS	R4,$88
	LDS	R5,$89		;  N*65536^2
	
	LDS	R16,$76
	LDS	R17,$77
	LDS	R18,$78
	LDS	R19,$79		; ; nx

	RCALL	DIV
	
	STS	RAM_CONST_C+0,R6
	STS	RAM_CONST_C+1,R7
	STS	RAM_CONST_C+2,R8
	STS	RAM_CONST_C+3,R9

	RCALL	RESULT_Cx_CAL
;      EEPROM	
	RCALL	SAVE
	RJMP	RES_GO
;***************************************************************************
INDEX_DEC_POINT:
	MOV	R20,R19		;    
	LDS	R21,DIAPAZON
	CPI	R21,1
	BRNE	IDP2
	CBR	R16,$80		; x.xx
	LDI	R19,$8C		; x.xxpF
	RJMP	IDP_OUT
IDP2:
	CPI	R21,2
	BRNE	IDP3
	CBR	R17,$80		; xx.x
	LDI	R19,$8C		; xx.xpF
	RJMP	IDP_OUT
IDP3:
	CPI	R21,3
	BRNE	IDP4
	LDI	R19,$8C		; xxxpF
	RJMP	IDP_OUT
IDP4:
	CPI	R21,4
	BRNE	IDP5
	CBR	R16,$80		; x.xx
	LDI	R19,$DC		; x.xxn
	SBIC	PIND,1
	RJMP	IDP5
	LDI	R19,$8D		; x.xxuH
	RJMP	IDP_OUT
IDP5:
	CPI	R21,5
	BRNE	IDP6
	CBR	R17,$80		; xx.x
	LDI	R19,$DC		; xx.xnF
	SBIC	PIND,1
	RJMP	IDP6
	LDI	R19,$8D		; xx.xuH
	RJMP	IDP_OUT
IDP6:
	CPI	R21,6
	BRNE	IDP7
	LDI	R19,$DC		; xxxnF
	SBIC	PIND,1
	RJMP	IDP7
	LDI	R19,$8D		; xxxuH
	RJMP	IDP_OUT
IDP7:
	CPI	R21,7
	BRNE	IDP8
	CBR	R16,$80		; x.xx
	LDI	R19,$8D		; x.xxuF
	SBIC	PIND,1
	RJMP	IDP8
	MOV	R19,R20
				; x.xxx(mH)
	RJMP	IDP_OUT
IDP8:
	CPI	R21,8
	BRNE	IDP9
	CBR	R17,$80		; xx.x
	LDI	R19,$8D		; xx.xuF
	SBIC	PIND,1
	RJMP	IDP9
	MOV	R19,R20		; xx.xx(mH)
	RJMP	IDP_OUT
IDP9:
	CPI	R21,9
	BRNE	IDP10
	LDI	R19,$8D		; xxxuF
	SBIC	PIND,1
	RJMP	IDP_OUT
	CBR	R18,$80
	MOV	R19,R20		; xxx.x(mH)
IDP10:
;	CPI	R21,10
;	BRNE	IDP_OUT
;	LDI	R19,$8D		; xxxx(uF)
;	SBIC	PIND,1
;	RJMP	IDP_OUT
;	MOV	R19,R20
;	LDI	R19,$8D		; xxxx(mH)
IDP_OUT:
	RET
;*************************************************
RES_Nx:
	LDI	ZL,$80

	LDI	YH,$00
	LDI	YL,$0A

	RJMP	GND_SET
;*************************************************
RES_nox:
	LDI	ZL,$70
	
	LDI	YH,$00
	LDI	YL,$00
GND_SET:
	LDI	R20,10
SET_RAM:
	LD	R21,Z+
	ST	Y+,R21
	DEC	R20
	BRNE	SET_RAM
	RET
;************************************************
SAVE:
	PUSH	R0
	PUSH	A
	LDI	ZL,LOW(COEFF_C)
	CLR	YH
	LDI	YL,LOW(RAM_COEFF_C)
E_RAM:
	RCALL	EEREAD
	LD	A,Y
	CPSE	A,R0
	RCALL	R0_A
	INC	YL
	INC	ZL
	CPI	ZL,LOW(E_END)
	BRNE	E_RAM
	POP	A
	POP	R0
	RET
R0_A:
	MOV	R0,A
;************************************************
;   EEPROM
; ZH,ZL -
; R0- 
;************************************************
EEWRITE:
	SBIC	EECR,EEWE
	RJMP	EEWRITE

	OUT     EEARL,ZL
	OUT     EEDR,R0

	SBI     EECR,EEMWE
	SBI     EECR,EEWE
EEWWAIT:
	SBIC    EECR,EEWE
	RJMP    EEWWAIT

	RET
;************************************************
;   EEPROM
; ZH,ZL-
; R0-
;************************************************
EEREAD:
	OUT     EEARL,ZL
	SBI     EECR,EERE

	IN      R0,EEDR

	RET
;************************************************
CODIR:
	LDI	ZL,$0A
	RCALL	CLEAR_R10	;   
	
	LDI	R25,4
COD:
	RCALL	SDVIG_4
	LDI	ZL,LOW (TTB_IND*2)
	ADD	ZL,R7
	LPM
	RCALL	SDVIG_8
	
	DEC	R25
	BRNE	COD
	
	RET
;************************************************
SDVIG_4:
	CLR	R7
	
	LDI	R24,4
SD1:
	LSL	R9
	ROL	R8
	ROL	R7
	
	DEC	R24
	BRNE	SD1
	
	RET
;************************************************
SDVIG_8:
	LDI	R24,8
SD9:
	ROL	R0
	ROL	R19
	ROL	R18
	ROL	R17
	ROL	R16

	DEC	R24
	BRNE	SD9
	
	RET
;************************************************
;   80    80  
;             80 
; R0...R9-MNOGIMOE,R10...R19-MNOGITEL,R20...R29-RAB
; R0...R9-RESULT
; R20...R29-RESULT
; ZL(R30)-TEMP
;************************************************
MULT:
	CLT		;   ,         
	
	LDI	ZL,80		;   
		
	CLR	R20
	CLR	R21
	CLR	R22
	CLR	R23
	CLR	R24
	CLR	R25
	CLR	R26
	CLR	R27
	CLR	R28
	CLR	R29		;   
OBRAT:
	LSR	R10
	ROR	R11
	ROR	R12
	ROR	R13
	ROR	R14
	ROR	R15
	ROR	R16
	ROR	R17
	ROR	R18
	ROR	R19		;       ,
	BRCC	NO_SUMMIR	; =0  
SUMMIR:
					; =1      
	ADD	R29,R9
	ADC	R28,R8
	ADC	R27,R7
	ADC	R26,R6
	ADC	R25,R5
	ADC	R24,R4
	ADC	R23,R3
	ADC	R22,R2
	ADC	R21,R1
	ADC	R20,R0
	BRLT	ERROR_MULT	; S- 
	BRCS	ERROR_MULT
NO_SUMMIR:
	LSL	R9
	ROL	R8
	ROL	R7
	ROL	R6
	ROL	R5
	ROL	R4
	ROL	R3
	ROL	R2
	ROL	R1
	ROL	R0		; *2

	DEC	ZL
	BRNE	OBRAT

	MOV	R0,R20
	MOV	R1,R21
	MOV	R2,R22
	MOV	R3,R23
	MOV	R4,R24
	MOV	R5,R25
	MOV	R6,R26
	MOV	R7,R27
	MOV	R8,R28
	MOV	R9,R29
		
	RET
		
ERROR_MULT:
	SET
	RET
;**********************************************************************
;   78    78  
; R0...R9-,  R10...R19-!!!!R0...R9-
; R20...R29-,ZL-TEMP, ZH-ZERO
;**********************************************************************
GDIV_ERROR:
	SET
GDIV_OUT2:
	RET
DIV:
	CLT		;   ,        
 		
	CLR	ZH	; zero-

	CLR	R20
	CLR	R21
	CLR	R22
	CLR	R23
	CLR	R24
	CLR	R25
	CLR	R26
	CLR	R27
	CLR	R28
	CLR	R29	;   
;**********************************************************************
;       
	TST	R0
	BRMI	GDIV_ERROR	;  , ERROR
		
	CP	R19,R29
	CPC	R18,R28
	CPC	R17,R27
	CPC	R16,R26
	CPC	R15,R25
	CPC	R14,R24
	CPC	R13,R23
	CPC	R12,R22
	CPC	R11,R21
	CPC	R10,R20
	BREQ	GDIV_ERROR	; YES,DELITEL=0, ERROR

	CP	R29,R9
	CPC	R28,R8
	CPC	R27,R7
	CPC	R26,R6
	CPC	R25,R5
	CPC	R24,R4
	CPC	R23,R3
	CPC	R22,R2
	CPC	R21,R1
	CPC	R20,R0
	BREQ	GDIV_OUT2	; YES,DELIMOE=0, REZULTAT=0

	CP	R9,R19
	CPC	R8,R18
	CPC	R7,R17
	CPC	R6,R16
	CPC	R5,R15
	CPC	R4,R14
	CPC	R3,R13
	CPC	R2,R12
	CPC	R1,R11
	CPC	R0,R10
	BRPL	DIV_GO1		; NO, DELITEL<DELIMOGO
	RJMP	DIV_OUT1
DIV_GO1:
	BRNE	DIV_GO
	RJMP	DIV_EQU		; =, =1
;***************************************************************************
;     
;***************************************************************************
DIV_GO:
	CLR	ZL		;   
DIV1:
	CP	R19,R9
	CPC	R18,R8
	CPC	R17,R7
	CPC	R16,R6
	CPC	R15,R5
	CPC	R14,R4
	CPC	R13,R3
	CPC	R12,R2
	CPC	R11,R1
	CPC	R10,R0
	BRCC	DIV2		; YES,DELITEL>DELIMOGO
      		
	LSL	R19
	ROL	R18
	ROL	R17
	ROL	R16
	ROL	R15
	ROL	R14
	ROL	R13
	ROL	R12
	ROL	R11
	ROL	R10		; DELITEL*2
		
	INC	ZL
	CPI	ZL,80
	BRNE	DIV1
;***************************************************************************
;     
;***************************************************************************
DIV2:
T_DIV0:
	CLT
		
	LSL	R9
	ROL	R8
	ROL	R7
	ROL	R6
	ROL	R5
	ROL	R4
	ROL	R3
	ROL	R2
	ROL	R1
	ROL	R0		;   *2

	CP	R19,R9
	CPC	R18,R8
	CPC	R17,R7
	CPC	R16,R6
	CPC	R15,R5
	CPC	R14,R4
	CPC	R13,R3
	CPC	R12,R2
	CPC	R11,R1
	CPC	R10,R0		;    ?
	BRCS	T_DIV20		; ,  0   
		
	SET			; ,   1   
T_DIV20:
	ROL	R29
	ROL	R28
	ROL	R27
	ROL	R26
	ROL	R25
	ROL	R24
	ROL	R23
	ROL	R22
	ROL	R21
	ROL	R20
	BRTS	T_DIV40

	SUB	R9,R19
	SBC	R8,R18
	SBC	R7,R17
	SBC	R6,R16
	SBC	R5,R15
	SBC	R4,R14
	SBC	R3,R13
	SBC	R2,R12
	SBC	R1,R11
	SBC	R0,R10
T_DIV40:
	DEC	ZL
	BRNE	T_DIV0
;***************************************************************************
;     
DIV_OUT:
	LSL	R9
	ROL	R8
	ROL	R7
	ROL	R6
	ROL	R5
	ROL	R4
	ROL	R3
	ROL	R2
	ROL	R1
	ROL	R0		; *2  0.*2

	CP	R9,R19
	CPC	R8,R18
	CPC	R7,R17
	CPC	R6,R16
	CPC	R5,R15
	CPC	R4,R14
	CPC	R3,R13
	CPC	R2,R12
	CPC	R1,R11
	CPC	R0,R10		;      >0.5 ?
	BRCS	DIV_OUT1	; ,  <0.5
				;   > 0.5,  1
;***************************************************************************
DIV_EQU:		
	SEC
		
	ADC	R29,ZH		
	ADC	R28,ZH		
	ADC	R27,ZH		
	ADC	R26,ZH		
	ADC	R25,ZH		
	ADC	R24,ZH		
	ADC	R23,ZH		
	ADC	R22,ZH		
	ADC	R21,ZH		
	ADC	R20,ZH		
DIV_OUT1:		
	MOV	R0,R20
	MOV	R1,R21
	MOV	R2,R22
	MOV	R3,R23
	MOV	R4,R24
	MOV	R5,R25
	MOV	R6,R26
	MOV	R7,R27
	MOV	R8,R28
	MOV	R9,R29

	CLT
	RET
;**********************************************************************
;       UMUP
; http://electronix.ru/forum/index.php?s=&showtopic=10934&view=findpost&p=324208
;**********************************************************************
BIN_BCD:
	CLR	R25		; BCD OUT 1'000'000'000,100'000'000
	CLR	R26		; BCD OUT 10'000'000,1'000'000
	CLR	R27		; BCD OUT 100'000,10'000
	CLR	R28		; BCD OUT 1'000,100
	CLR	R29		; BCD OUT 10,1

	LDI	R24,32
bin32bcd10:
	subi r29,-0x33	;add 0x33
	sbrs r29, 3	;if carry to bit 3
	subi r29, 3	;subtract 3
	sbrs r29, 7	;if carry to bit 7
	subi r29, 0x30	;subtract 0x30

	subi r28,-0x33      ; \n" /*add 0x33*/
	sbrs r28, 3         ; \n" /*if carry to bit 3,*/
	subi r28, 3         ; \n" /*subtract 3*/
	sbrs r28, 7         ; \n" /*if carry to bit 7,*/
	subi r28, 0x30      ; \n" /*subtract 0x30*/

	subi r27,-0x33       ;\n" /*add 0x33*/
	sbrs r27, 3          ;\n" /*if carry to bit 3,*/
	subi r27, 3          ;\n" /*subtract 3*/
	sbrs r27, 7          ;\n" /*if carry to bit 7,*/
	subi r27, 0x30       ;\n" /*subtract 0x30*/

	subi r26,-0x33       ;\n" /*add 0x33*/
	sbrs r26, 3          ;\n" /*if carry to bit 3,*/
	subi r26, 3          ;\n" /*subtract 3*/
	sbrs r26, 7          ;\n" /*if carry to bit 7,*/
	subi r26, 0x30       ;\n" /*subtract 0x30*/

	subi r25,-0x33       ;\n" /*add 0x33*/
	sbrs r25, 3          ;\n" /*if carry to bit 3,*/
	subi r25, 3          ;\n" /*subtract 3*/
	sbrs r25, 7          ;\n" /*if carry to bit 7,*/
	subi r25, 0x30       ;\n" /*subtract 0x30*/

	lsl r29
	rol r28
	rol r27
	rol r26		; \n" /*shift out buffer*/
	rol r25
   
	sbrc R6, 7	;skip if msbit of input =0*/
	ori  R29, 1        ;set lsb of output*/

	lsl R9
	rol R8
	rol R7		;shift input*/
	rol R6
   
	dec R24		;\n"
	brne bin32bcd10	;repeat for all bits*/

	MOV	R5,R25
	MOV	R6,R26
	MOV	R7,R27
	MOV	R8,R28
	MOV	R9,R29

	RET
;************************************************
CLEAR_R64:
	LDI	R21,$40
	RJMP	CLEAR0
CLEAR_R10:
	LDI	R21,10
CLEAR0:
	CLR	R20
	ST	Z+,R20
	DEC	R21
	BRNE	CLEAR0
	RET
;***************************************************************************
BAND:
	LDI	R20,$01		;    C
	SBIS	PIND,1
	LDI	R20,$04		;    L
BAND_GO:	
	STS	DIAPAZON,R20
BAND_L:
	LDI	ZL,$0A
	RCALL	CLEAR_R10	;   R10...R19
	
	LDI	R18,$27
	LDI	R19,$0B		;   9'995
	
	CP	R9,R19
	CPC	R8,R18
	CPC	R7,R17
	CPC	R6,R16
	CPC	R5,R15
	CPC	R4,R14
	CPC	R3,R13
	CPC	R2,R12
	CPC	R1,R11
	CPC	R0,R10
	BRCS	BAND_OUT
	
	LDI	ZL,$0A
	RCALL	CLEAR_R10	;   R10...R19
	LDI	R19,10		;  10
	RCALL	DIV

	LDS	R20,DIAPAZON	
	INC	R20
	STS	DIAPAZON,R20
	CPI	R20,11
	BRCS	BAND_L
BAND_OUT:
	RET
;************************************************
RABOTA:
	CLR	XH
	CLR	XL		;   1=0 

	CLR	R22
	CLR	R23
	CLR	YH
	CLR	YL		;  Nx=0
	
	CLR	R24		;   

	CLT

	LDI	R20,$C8		; OVER_T1+OCR1A+CAPT
	OUT	TIMSK,R20	; 
	OUT	TIFR,R20	;  FLAG's OVER_T1, FLAG_ICP
	
	OUT	GIMSK,ZH	;   INT0,INT1

	SEI
WAIT:
;	SLEEP
	BRTC	WAIT
	CLI
W_IND:
	LDI	R20,$40		; OCR1A
	OUT	TIMSK,R20	;  
	OUT	GIMSK,R20	;  INT0
	
	SER	R20
	OUT	TIFR,R20	;  FLAG's OVER_T1, FLAG_ICP
	OUT	GIFR,R20

	CLT
	SEI
WAIT_IND:
;	SLEEP
	BRTC	WAIT_IND	;    
	CLI
	CLT
;***************************************************************************
	CPI	XH,11
	BRCS	RAB_OUT
	SER	R20		; 
	STS	RAM_PEREGRUZKA,R20
RAB_OUT:
; $70...$79- nx
; $80...$89- Nx
	RET
;************************************************
CONV:
	COM	R9
	COM	R8
	COM	R7
	COM	R6
	COM	R5
	COM	R4
	COM	R3
	COM	R2
	COM	R1
	COM	R0

	LDI	R20,1
	ADD	R9,R20
	ADC	R8,ZH
	ADC	R7,ZH
	ADC	R6,ZH
	ADC	R5,ZH
	ADC	R4,ZH
	ADC	R3,ZH
	ADC	R2,ZH
	ADC	R1,ZH
	ADC	R0,ZH

	RET
;************************************************
;************************************************
;************************************************
;************************************************
CAPT:
	SBRC	R24,7
	RJMP	CAPT_1
	SBR	R24,$80		;   
	
	IN	R11,ICR1L
	IN	R10,ICR1H
	CLR	XH
	CLR	XL		;    nx_begin
		
	RETI
CAPT_1:
	ADIW	YL,1		; Nx=Nx+1
	ADC	R23,ZH
	ADC	R22,ZH
		
	CPI	XL,50		;   ?
	CPC	XH,ZH
	BRCC	CAPT_2		; 
	RETI			; 
CAPT_2:
	IN	R9,ICR1L
	IN	R8,ICR1H	;   nx

	SUB	R9,R11
	SBC	R8,R10
	SBC	XL,ZH
	SBC	XH,ZH		; nx-nx_begin
		
	STS	$76,XH
	STS	$77,XL
	STS	$78,R8
	STS	$79,R9		; nx
		
	STS	$86,R22
	STS	$87,R23
	STS	$88,YH
	STS	$89,YL		;Nx
		
	SET
	RETI
;***************************************************************************
;***************************************************************************
;***************************************************************************
;***************************************************************************
;***************************************************************************
TIMER_COMP1:
	SEI
	LDI	R20,$FF
	LDI	R21,$43
	OUT	PORTB,R20	;    
	OUT	PORTD,R21	;  
	
	LDI	ZL,LOW(DC_ANODE*2)
	LDS	R20,ANODE
	ADD	ZL,R20
	LPM

	LDI	ZL,IND100	;   ZL  IND100
	ADD	ZL,R20
	LD	R21,Z		;      R21
	
	OUT	PORTD,R0
	OUT	PORTB,R21	;   
	
	INC	R20
	ANDI	R20,$03		;     
	STS	ANODE,R20
	
	IN	R21,OCR1AL
	IN	R20,OCR1AH
	
	LDI	R18,HIGH(16433)
	LDI	R19,LOW(16433)
	
	ADD	R21,R19
	ADC	R20,R18
	
	OUT	OCR1AH,R20
	OUT	OCR1AL,R21	;    OCR1A   

	RETI
;*************************************************
;	END
